package org.example;
import org.graphstream.algorithm.generator.Generator;
import org.graphstream.algorithm.generator.RandomGenerator;
import org.graphstream.graph.Graph;
import org.graphstream.graph.implementations.DefaultGraph;
import org.graphstream.graph.implementations.SingleGraph;
import org.graphstream.stream.file.FileSource;
import org.graphstream.stream.file.FileSourceEdge;
import org.graphstream.stream.file.FileSourceFactory;
import org.graphstream.algorithm.Toolkit;
import org.graphstream.graph.*;
import org.graphstream.graph.BreadthFirstIterator;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.time.Clock;
import java.util.*;

import static org.graphstream.algorithm.Toolkit.*;

/**
 * Hello world!
 *
 */
public class App 
{
    public static void main(String ... args) throws IOException {
        String filePath = "com-dblp.ungraph.txt";
        Graph g = new DefaultGraph("g");
        FileSource fs = new FileSourceEdge();
        fs.addSink(g);
        System.setProperty("org.graphstream.ui", "swing");

        Graph graph = new SingleGraph("Random");
        Generator gen = new RandomGenerator(6.62);
        gen.addSink(graph);
        gen.begin();
        for (int i = 0; i < 317080; i++)
            gen.nextEvents();


        System.out.println(averageClusteringCoefficient(graph));
        System.out.println(isConnected(graph));
        gen.end();


        //g.nodes();
        //g.display();

        try {
            fs.readAll("com-dblp.ungraph.txt");
            fs.begin("com-dblp.ungraph.txt");
            System.out.println(g.getNodeCount());
            System.out.println(g.getEdgeCount());
            System.out.println(averageDegree(g));
            System.out.println(isConnected(g));
            System.out.println("noued"+g.getNode(196293).getId());
            System.out.println(averageClusteringCoefficient(g));
            // exercice 5
            int[] dd2 = new int[317080*1000];
            int i =0;
            for (int k =0;k<1000;k++) {
                BreadthFirstIterator bf = new BreadthFirstIterator(randomNode(g));
                while (bf.hasNext()) {
                    Node v = bf.next();
                    dd2[i] = bf.getDepthOf(v);
                    i++;
                }
            }
            //System.out.println(Arrays.toString(dd2));
            OptionalDouble moyenne = Arrays.stream(dd2).average();
            System.out.println(moyenne);

            int[] dd3 = new int[317080*1000];
            int i2 =0;
            for (int k =0;k<1000;k++) {
                BreadthFirstIterator bf = new BreadthFirstIterator(randomNode(graph));
                while (bf.hasNext()) {
                    Node v = bf.next();
                    dd3[i2] = bf.getDepthOf(v);
                    i2++;
                }
            }
            OptionalDouble moyenne2 = Arrays.stream(dd3).average();
            System.out.println(moyenne2);



            /*
            for (Node n:g) {
                int i =0;
                System.out.println("node : " + n + " à degre" + degreeDistribution(g)[i]);
                i++;
            }


            for(int i =0; i<  degreeDistribution(g).length;i++){
                System.out.println("degre : " + i + " à un nombre de noeud " + degreeDistribution(g)[i]);

            }

             */
            int[] dd = Toolkit.degreeDistribution(graph);
            for (int k = 0; k < dd.length; k++) {
                if (dd[k] != 0) {
                    //System.out.printf(Locale.US, "%6d%20.8f%n", k, (double) dd[k] / graph.getNodeCount());
                }
            }
            Process proc = Runtime.getRuntime().exec("gnuplot plot_dd.gnu");
            BufferedReader reader =
                    new BufferedReader(new InputStreamReader(proc.getInputStream()));

            String line = "";
            while ((line = reader.readLine()) != null) {
                //System.out.print(line + "\n");
            }
            for (Iterator<Node> it = new BreadthFirstIterator(g.getNode(1)); it.hasNext(); ) {
                //  un pointeur qui pointe sur le noeud voisin du noeud courant
                Node voisin = it.next();

            }
        } catch (IOException e) {
            e.printStackTrace();
        }
        try {
            fs.end();
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            fs.removeSink(g);
        }


    }}
